// **********************************************************************
//
// Generated by the ORBacus IDL to Java Translator
//
// Copyright (c) 1998
// Object-Oriented Concepts, Inc.
// Billerica, MA, USA
//
// Copyright (c) 1998
// Object-Oriented Concepts GmbH
// Ettlingen, Germany
//
// All Rights Reserved
//
// **********************************************************************

// Version: 3.1.1
// License: non-commercial

package nsdb;

//
// IDL:nsdb/EmblSeqWriter:1.0
//
public interface EmblSeqWriter extends EmblSeq
{

    //
    // IDL:nsdb/EmblSeqWriter/createNucFeature:1.0
    //
    /**
     * Create a new feature in this EmblSeq object.
     * @parm key Type of the feature to be created
     * @parm location_string The location of the new NucFeature
     * @raises LocationParse If the location string is not a valid location.
     * @raises type::IndexOutOfRange If any part of the location is beyond the
     *   end of the sequence
     * @raises InvalidKey if the given key is not a possible EMBL key.
     **/
    public NucFeatureWriter
    createNucFeature(String key,
                     String location)
        throws LocationParse,
               type.IndexOutOfRange,
               InvalidKey,
               ReadOnly;

    //
    // IDL:nsdb/EmblSeqWriter/remove:1.0
    //
    /**
     * Remove the given feature.
     **/
    public void
    remove(NucFeature nuc_feature)
        throws ReadOnly;

    //
    // IDL:nsdb/EmblSeqWriter/getNucFeaturesInRange:1.0
    //
    /**
     * retrieve sequence of NucFeatureList associated with
     * the nucleotide sequence that are within the given range of bases.
     * @raises type::NoResult if no features are owned by the sequence
     * @raises type::IndexOutOfRange if either of start_base or end_base is
     *  less than 1 or greater than the length of the sequence.
     **/
    public NucFeature[]
    getNucFeaturesInRange(int start_base,
                          int end_base)
        throws type.NoResult,
               type.IndexOutOfRange;

    //
    // IDL:nsdb/EmblSeqWriter/getNucFeatureCount:1.0
    //
    /**
     *  Return the number of features
     **/
    public int
    getNucFeatureCount();

    //
    // IDL:nsdb/EmblSeqWriter/getFeatureAtIndex:1.0
    //
    /**
     * Return the ith NucFeature from this Entry.  The feature are returned in
     * a consistent order, sorted by the first base of each Feature.
     * @raises type::IndexOutOfRange if the index is less than 0 or greater
     *   than the number of features.
     **/
    public NucFeature
    getFeatureAtIndex(int i)
        throws type.IndexOutOfRange;

    //
    // IDL:nsdb/EmblSeqWriter/indexOf:1.0
    //
    /**
     * Return the index of the given Feature.  This does the reverse of
     * getFeatureAtIndex ().  Returns -1 if the given NucFeature is not in
     * this EmblSeq object.
     **/
    public int
    indexOf(NucFeature feature);

    //
    // IDL:nsdb/EmblSeqWriter/commit:1.0
    //
    /**
     *  commit any pending changes to the database immediately.
     **/
    public void
    commit()
        throws CommitFailed;

    //
    // IDL:nsdb/EmblSeqWriter/getDatestamp:1.0
    //
    /**
     * Return a Datestamp that will be passed to the set methods on the
     * EmblSeqWriter methods and NucFeatureWriter methods.  The object that is
     * returned represents the time when the entry was last changed (the last
     * time a feature was added, removed or changed location).
     **/
    public Datestamp
    getDatestamp();
}
