// **********************************************************************
//
// Generated by the ORBacus IDL to Java Translator
//
// Copyright (c) 1998
// Object-Oriented Concepts, Inc.
// Billerica, MA, USA
//
// Copyright (c) 1998
// Object-Oriented Concepts GmbH
// Ettlingen, Germany
//
// All Rights Reserved
//
// **********************************************************************

// Version: 3.1.1
// License: non-commercial

package nsdb;

//
// IDL:nsdb/Location:1.0
//
/**
 * A location is built from one or more nodes forming a tree
 * local node IDs are only unique within a location tree
 * the root node has id == 0
 * the Node id defines the position of the node in the sequence<LocationNode>
 * The value is relative to the current (parent) node
 * e.g if the current node is at position x in the LocationNodes sequence
 *     and there is a childId with value j
 *     then the position of this child in the LocationNodes sequence will be x+j
 **/
public interface Location extends org.omg.CORBA.Object
{

    //
    // IDL:nsdb/Location/VirtualSegment_ltc:1.0
    //
    /**
     * The sequence segment is derived from another sequence
     **/
    public static final int VirtualSegment_ltc = (int)(1L);

    //
    // IDL:nsdb/Location/PhysicalSegment_ltc:1.0
    //
    /**
     * The sequence segment is explicitly given as a DNA string.
     **/
    public static final int PhysicalSegment_ltc = (int)(2L);

    //
    // IDL:nsdb/Location/Gap_ltc:1.0
    //
    /**
     * Sequence is unknown. Only it's (estimated) size in known.
     **/
    public static final int Gap_ltc = (int)(3L);

    //
    // IDL:nsdb/Location/Operator_ltc:1.0
    //
    /**
     * defines how to link a set of LocationNodes
     **/
    public static final int Operator_ltc = (int)(4L);

    //
    // IDL:nsdb/Location/getLocationString:1.0
    //
    /**
     * retrieve 
     * <A href="http://www.ebi.ac.uk/ebi_docs/embl_db/ft/components.html#location">
     * string representation of location</A>
     **/
    public String
    getLocationString();

    //
    // IDL:nsdb/Location/getNodes:1.0
    //
    /**
     * retrieve tree representation of location
     **/
    public nsdb.LocationPackage.LocationNode_u[]
    getNodes();

    //
    // IDL:nsdb/Location/getSeq:1.0
    //
    /**
     * Create nucleotide sequence defined by location. This can imply getting
     * fragments from multiple sequences and concatenating.
     * If it is not possible to resolve the location into a single sequence
     * (e.g. when it contains a 'group' operator, or gap nodes)
     * each fragment will be returned as a seperate string. No assumption should be
     * made on the order, if multiple fragments are returned
     * @raises InexactLocation if an exact sequence cannot be
     *   determined due to the location being inexact
     **/
    public String
    getSeq()
        throws InexactLocation;
}
