// **********************************************************************
//
// Generated by the ORBacus IDL to Java Translator
//
// Copyright (c) 1998
// Object-Oriented Concepts, Inc.
// Billerica, MA, USA
//
// Copyright (c) 1998
// Object-Oriented Concepts GmbH
// Ettlingen, Germany
//
// All Rights Reserved
//
// **********************************************************************

// Version: 3.1.1
// License: non-commercial

package nsdb;

//
// IDL:nsdb/NucSeq:1.0
//
/**
 * Generic Nucleotide sequence interface.
 * The accession number is retrieved using the getBioSeqId method inherited from BioSeq.
 * @see EmblSeq
 * @see seqdb::BioSeq
 **/
public interface NucSeq extends seqdb.BioSeq
{

    //
    // IDL:nsdb/NucSeq/getSeq:1.0
    //
    /**
     * retrieve string representation of nucleotide sequence. Each character
     * in the string is a 
     *   <href="http://www.ebi.ac.uk/ebi_docs/embl_db/ft/iupac_codes.html">
     *   IUPAC nucleotide base code</A>
     * <P>
     * This method can be used instead of the getAnySeq() 
     * method in seqdb::BioSeq
     * @see seqdb::BioSeq
     **/
    public String
    getSeq();

    //
    // IDL:nsdb/NucSeq/getCheckSum:1.0
    //
    /**
     * Checksum on sequence to allow validation.
     * 
     **/
    public int
    getCheckSum();

    //
    // IDL:nsdb/NucSeq/getTopology:1.0
    //
    /**
     * topology of the nucleotide sequence
     * @see meta::nsdb
     **/
    public String
    getTopology();

    //
    // IDL:nsdb/NucSeq/getMoleculeType:1.0
    //
    /**
     * molecule type of the nucleotide sequence
     * @see meta::nsdb
     **/
    public String
    getMoleculeType();

    //
    // IDL:nsdb/NucSeq/getNucFeatures:1.0
    //
    /**
     * retrieve sequence of NucFeatureList associated with
     * the nucleotide sequence.
     * A sequence has <I>ownership</I> of all these 
     * features. It is possible on the other hand that
     * features, owned by another sequence, reference 
     * the current sequence. Currently there is no way to find out.
     * @raises type::NoResult if no features are owned by the sequence
     **/
    public NucFeature[]
    getNucFeatures()
        throws type.NoResult;

    //
    // IDL:nsdb/NucSeq/getLocalLocation:1.0
    //
    /**
     * A location of a NucFeature can span multiple sequences.
     * If only the location of a feature relevant to the current
     * sequence is required, this method will calculate that.
     * @parm nuc_feature Feature from which location needs to be
     *   intersected with the current sequence.
     * @raises type::InvalidRelation if the nuc_feature 
     *   is not associated to the current sequence
     **/
    public Location
    getLocalLocation(NucFeature nuc_feature)
        throws type.InvalidRelation;

    //
    // IDL:nsdb/NucSeq/getOrganisms:1.0
    //
    /**
     * organism(s) from which the NucSeq was obtained.
     * If the sequence is chimeric, multiple organisms will be returned.
     * For each organism, there should be a source feature associated
     * with the current sequence. This source feature has a location
     * defining which part of the sequence was derived from the specified
     * organism.
     * This method provides a shortcut to:
     * invoke getNucFeaturesByKey("source"), invoke getQualifiers() on each 
     * source feature and loop through qualifiers to find DbXref. 
     * @raises type::NoResult if no source features are associated with
     * the sequence (should never happen).
     **/
    public type.DbXref[]
    getOrganisms()
        throws type.NoResult;

    //
    // IDL:nsdb/NucSeq/getNucFeaturesByKey:1.0
    //
    /**
     * retreive all features of a specific kind (FeatureKey)
     * @parm key Type of features to be retrieved
     * @raises type::NoResult if the sequence has no associated features
     *     of the requested type.
     * @raises type::InvalidArgumentValue if the key is not a 
     * <A href="http://www.ebi.ac.uk/ebi_docs/embl_db/ft/feature_table.html">
     * valid feature key</A>
     * @see NucFeature
     **/
    public NucFeature[]
    getNucFeaturesByKey(String key)
        throws type.NoResult,
               type.InvalidArgumentValue;

    //
    // IDL:nsdb/NucSeq/getSubSeq:1.0
    //
    /**
     * Create nucleotide sequence of the segment specified
     * The first base in the sequence is numbered 1
     *
     * @parm start first base of sub-sequence (inclusive)
     * @parm end last base of sub-sequence (inclusive)
     * @raises type::IndexOutOfRange if start &lt 1
     *   or end &gt length
     **/
    public String
    getSubSeq(int start,
              int end)
        throws type.IndexOutOfRange;

    //
    // IDL:nsdb/NucSeq/getSubSeqByFeature:1.0
    //
    /** 
     * Create nucleotide sequence of the location derived from the specified feature
     * and contained in the current NucSeq.
     * @raises type::InvalidRelation if the nuc_feature 
     *   is not associated to the current sequence
     * @raises InexactLocation if an exact sequence cannot be
     *   determined due to the feature's location being inexact
     **/
    public String
    getSubSeqByFeature(NucFeature feature)
        throws type.InvalidRelation,
               InexactLocation;

    //
    // IDL:nsdb/NucSeq/getReferenceLocation:1.0
    //
    /**
     * @raises type::InvalidRelation if reference does not exist
     * @raises type::InvalidRelation if reference is not 
     *   associated to the current sequence
     * @raises type::NoResult if there is no location associated with this reference
     **/
    public Location
    getReferenceLocation(String reference_id)
        throws type.InvalidRelation,
               type.NoResult;
}
